﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.Phone.Controls;
using Telerik.Windows.Controls;

namespace OrientationAndViewPortItems
{
    public partial class MainPage : PhoneApplicationPage
    {
        public MainPage()
        {
            this.InitializeComponent();
            var items = new List<string>();
            for (int i = 0; i < 30; i++)
            {
                items.Add(string.Format("item {0}", i));
            }

            this.dblb.ItemsSource = items;
        }

        private void Button_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            var firstItem = this.dblb.ViewportItems.FirstOrDefault();
            var orientation = this.dblb.VirtualizationStrategyDefinition.Orientation;
           
            if (orientation == System.Windows.Controls.Orientation.Horizontal)
            {
                this.dblb.VirtualizationStrategyDefinition = new StackVirtualizationStrategyDefinition { Orientation = System.Windows.Controls.Orientation.Vertical };
            }
            else
            {
                this.dblb.VirtualizationStrategyDefinition = new StackVirtualizationStrategyDefinition { Orientation = System.Windows.Controls.Orientation.Horizontal };
            }

            if (firstItem != null)
            {
                this.Dispatcher.BeginInvoke(() =>
                {
                    this.dblb.BringIntoView(firstItem.DataContext);
                });
            }
        }
    }
}